Fix make-array transforms.
[sbcl.git] / make.sh
diff --git a/make.sh b/make.sh
index 32066f7..a82b3c2 100755 (executable)
--- a/make.sh
+++ b/make.sh
@@ -1,4 +1,9 @@
 #!/bin/sh
+set -e
+
+LANG=C
+LC_ALL=C
+export LANG LC_ALL
 
 # "When we build software, it's a good idea to have a reliable method
 # for getting an executable from it. We want any two reconstructions
 # provided with absolutely no warranty. See the COPYING and CREDITS
 # files for more information.
 
-# The value of SBCL_XC_HOST should be a command to invoke the
-# cross-compilation Lisp system in such a way that it reads commands
-# from standard input, and terminates when it reaches end of file on
-# standard input. Some suitable values are:
-#   "sbcl"        to use an existing SBCL binary as a cross-compilation host
-#   "sbcl --sysinit /dev/null --userinit /dev/null"
-#                 to use an existing SBCL binary as a cross-compilation host
-#                 even though you have stuff in your initialization files
-#                 which makes it behave in such a non-standard way that
-#                 it keeps the build from working
-#   "sbcl --disable-debugger"
-#                 to use an existing SBCL binary as a cross-compilation host
-#                 and tell it to handle errors as best it can by itself
-#                 (probably by dying with an error code) instead of waiting
-#                 endlessly for a programmer to help it out with input
-#                 on *DEBUG-IO*
-#   "lisp -batch" to use an existing CMU CL binary as a cross-compilation host
-#   "lisp -noinit -batch" 
-#                 to use an existing CMU CL binary as a cross-compilation host
-#                 when you have weird things in your .cmucl-init file
-#   "openmcl --batch"
-#                 to use an OpenMCL binary as a cross-compilation host
-#   "clisp"
-#                 to use a CLISP binary as a cross-compilation host
-#
-# FIXME: Make a more sophisticated command line parser, probably
-# accepting "sh make.sh --xc-host foolisp" instead of the
-# the present "sh make.sh foolisp".
-# FIXME: Tweak this script, and the rest of the system, to support
-# a second bootstrapping pass in which the cross-compilation host is
-# known to be SBCL itself, so that the cross-compiler can do some
-# optimizations (especially specializable arrays) that it doesn't
-# know how to implement how in a portable way. (Or maybe that wouldn't
-# require a second pass, just testing at build-the-cross-compiler time
-# whether the cross-compilation host returns suitable values from 
-# UPGRADED-ARRAY-ELEMENT-TYPE?)
-# FIXME: --noprogrammer was deprecated in sbcl-0.7.5, replaced by 
-# --disable-debugger. We still use the old form here because the
-# change was not preannounced, and it would be rude to make our new
-# version of SBCL unbootstrappable by immediately prior versions.
-# But in a year or so the --noprogrammer here can change to
-# --disable-debugger (and the deprecated --noprogrammer support can
-# go away completely).
-SBCL_XC_HOST="${1:-sbcl --noprogrammer}"
-export SBCL_XC_HOST
-echo //SBCL_XC_HOST=\"$SBCL_XC_HOST\"
-
-# the GNU dialect of "make" -- easier to find or port it than to
-# try to figure out how to port to the local dialect...
-if [ "$GNUMAKE" != "" ] ; then
-  # The user is evidently trying to tell us something.
-  GNUMAKE="$GNUMAKE"
-elif [ -x "`which gmake`" ] ; then
-  # "gmake" is the preferred name in *BSD.
-  GNUMAKE=gmake
-elif [ "GNU Make" = "`make -v | head -n 1 | cut -b 0-8`" ]; then
-  GNUMAKE=make
-else
-  echo "GNU Make not found. Try setting the environment variable GNUMAKE."
-  exit 1
-fi
+# If you're cross-compiling, make-config.sh should "do the right
+# thing" when run on the target machine, with the minor caveat that
+# any --xc-host parameter should be suitable for the host machine
+# instead of the target.
+sh make-config.sh "$@" || exit $?
 
-export GNUMAKE
-echo //GNUMAKE=\"$GNUMAKE\"
+. output/prefix.def
+. output/build-config
 
+build_started=`date`
+echo "//Starting build: $build_started"
+# Apparently option parsing succeeded. Print out the results.
+echo "//Options: --prefix='$SBCL_PREFIX' --xc-host='$SBCL_XC_HOST'"
 
-# If you're cross-compiling, you should probably just walk through the
-# make-config.sh script by hand doing the right thing on both the host
-# and target machines.
-sh make-config.sh || exit 1
+# Enforce the source policy for no bogus whitespace
+tools-for-build/canonicalize-whitespace
 
 # The make-host-*.sh scripts are run on the cross-compilation host,
 # and the make-target-*.sh scripts are run on the target machine. In
@@ -98,7 +49,7 @@ sh make-config.sh || exit 1
 #     identify the target architecture).
 #   On the host system:
 #     SBCL_XC_HOST=<whatever> sh make-host-1.sh
-#   Copy src/runtime/genesis/*.h from the host system to the target 
+#   Copy src/runtime/genesis/*.h from the host system to the target
 #     system.
 #   On the target system:
 #     sh make-target-1.sh
@@ -113,18 +64,51 @@ sh make-config.sh || exit 1
 # Or, if you can set up the files somewhere shared (with NFS, AFS, or
 # whatever) between the host machine and the target machine, the basic
 # procedure above should still work, but you can skip the "copy" steps.
-time sh make-host-1.sh   || exit 1
-time sh make-target-1.sh || exit 1
-time sh make-host-2.sh   || exit 1
-time sh make-target-2.sh || exit 1
-time sh make-target-contrib.sh || exit 1
+time sh make-host-1.sh
+time sh make-target-1.sh
+time sh make-host-2.sh
+time sh make-target-2.sh
+time sh make-target-contrib.sh
 
-# Sometimes people used to see the "No tests failed." output from the last
-# DEFTEST in contrib self-tests and thing that's all that is. So...
+NCONTRIBS=`find contrib -name Makefile -print | wc -l`
+NPASSED=`find obj/asdf-cache -name test-passed.test-report -print | wc -l`
+echo
+echo "The build seems to have finished successfully, including $NPASSED (out of $NCONTRIBS)"
+echo "contributed modules. If you would like to run more extensive tests on"
+echo "the new SBCL, you can try:"
+echo
+echo "  cd tests && sh ./run-tests.sh"
+echo
+echo "  (All tests should pass on x86/Linux, x86/FreeBSD4, and ppc/Darwin. On"
+echo "  other platforms some failures are currently expected; patches welcome"
+echo "  as always.)"
 echo
-echo The build seems to have finished successfully. If you would like
-echo run more extensive tests on the new SBCL, you can try 
-echo "  cd tests && sh ./run-tests.sh."
-echo "(but expect some failures on non-x86 platforms)."
+echo "To build documentation:"
+echo
+echo "  cd doc/manual && make"
+echo
+echo "To install SBCL (more information in INSTALL):"
+echo
+echo "  sh install.sh"
 
-date
+# This is probably the best place to ensure people will see this.
+if test -n "$legacy_xc_spec"
+then
+    echo <<EOF
+******************************************************************************
+**
+**  Old-style XC-host specification detected: '$SBCL_XC_HOST'
+**
+**  Since 1.0.41.45 SBCL expects the XC-host to be specified using
+**  the --xc-host='myhost' command line option, not with a positional
+**  argument. The legacy style still works, but will not be supported
+**  indefinitely. Please update your build procedure.
+**
+******************************************************************************
+EOF
+fi
+
+build_finished=`date`
+echo
+echo "//build started:  $build_started"
+echo "//build finished: $build_finished"